/*	mod_kssl.h  --  Adds kerberos config directives.  Needs mod_ssl.
**
**	19991110 	VRS 	Started.
*/

#ifndef MOD_KSSL_H
#define MOD_KSSL_H 1

#ifndef	NO_KRB5

#define	KSSL_VERSION		"kssl/0.3"

#define	KSSL_SVC_DEFAULT	"kssl"
#define	KSSL_KTAB_PREFIX	"/etc/krb5.keytab."

#define	KSSL_SVC_N	1
#define	KSSL_KTAB_N	2
#define	KSSL_GRP_N	3
#define	KSSL_RLM_N	4
#define	KSSL_PRC_N	5
#define	KSSL_USR_N	6
#define	KSSL_EDT_N	7
#define	KSSL_SSL_N	8
#define	KSSL_NONC_N	9
#define	KSSL_NONL_N	10
#define	KSSL_MAXT_N	11
#define	KSSL_AUTH_N	12

#define	KSSL_BAD_RLM	1
#define	KSSL_BAD_USR	2
#define	KSSL_BAD_PRC	4
#define	KSSL_BAD_GRP	8

#include "nonce.h"

/*	per-server directives
*/
typedef struct {
	char	*k_service;			/* Service name, usually "kssl" 			*/
	char	*k_keytab;			/* Keytab filename, /etc/krb5.keytab.kssl	*/
	table	*k_rescheme;		/* List of URLS to rescheme http -> https	*/
	table	*k_https;			/* List of SSL servers to be visited		*/
	table	*k_auths;			/* List of port access auth methods to use	*/
	Cookie	*cookie;
	}	kssl_srvr_cfg;

/*	per-directory directives
*/
typedef struct {
	table	*k_realm;
	table	*k_princ;
	table	*k_user;
	}	kssl_dir_cfg;


void			kssl_init_Module(server_rec *srvr_rec, pool *p);
char			*kssl_get_keytab(pool *p, kssl_srvr_cfg *cfg);
void			*kssl_create_srvr_cfg(pool *p, server_rec *s);
void			*kssl_create_dir_cfg(pool *p, char *path);
void 			*kssl_merge_srvr_cfg(pool *p, void *base, void *new);
void 			*kssl_merge_dir_cfg(pool *p, void *base, void *new);
const char		*ks_directive(cmd_parms *parms, void *mconfig, const char *val);
const char		*kd_directive(cmd_parms *parms, void *mconfig, const char *val);
int 			kssl_apply_srvr_cfg(conn_rec *conn, SSL *s);
int 			kssl_apply_client_princ(request_rec *r);
int 			kssl_status_handler(request_rec *r);
int 			url_in_kssl_list(server_rec *s, const char *url);

int				update_ns_cookie_file(server_rec *s, Cookie *c);
int				update_ns_prefs_file(server_rec *s, Cookie *c);


#endif	/* NO_KRB5 */
#endif /* MOD_KSSL_H */

