/*	nonce.h  --  Headers for nonce.c
**
**	20000530	VRS 	Split out from mod_kssl.h
*/

#ifndef NONCE_H
#define NONCE_H 1

#ifndef	NO_KRB5

#define	COOKIE_TAG		"ksslproxy"

#define	AUTH_NONE		0x00
#define	AUTH_COOK		0x10
#define	AUTH_LANG		0x20

/*	cookie parameters
*/
typedef struct {
	char	*nonce;				/* Cookie value for local port access 		*/
	int 	nonce_len;			/* Cookie length; 0 disables port security	*/
	int 	tries;				/* current number of connection attempts, 	*/
	int 	max_tries;			/* max failed attempts until proxy exits	*/
	int 	ns_auths;			/* port authentication methods for Netscape	*/
	int 	ms_auths;			/* currently unimplemented					*/
	}	Cookie;

/*	length-delimited name-value pairs
*/
typedef struct	{
	char	*keyp;
	char	*valp;
	int 	keylen;
	int 	vallen;
	}	KeyVal;

int 	read_file(char *cf, char **path, char **data);
int 	write_ns_cookie_file(char *dl, char *nonce, char *path, char *data);
int 	write_ns_prefs_file(int port, char *nonce, char *path, char *data);
char 	*backup_ns_entries(KeyVal *kv1, KeyVal *kv2, KeyVal *kv3);
void	parse_auth_method(Cookie *cookie, const char *val);

#endif	/* NO_KRB5 */
#endif	/* NONCE_H */

